package analysis

import dex.{DexClass, DexMethod}

/**
  * Program point.
  */
case class PP(c: DexClass, m: DexMethod, pc: Int) {

  /**
    * Returns a new program point with the program counter increased by 1.
    */
  def + : PP = {
    this.copy(pc = this.pc + 1)
  }

  override def toString: String =
    s"${c.name},${m.name},$pc"

}
