package dex

import org.jf.dexlib2.iface.instruction.Instruction

case class DexClass(
    name: String,
    superClass: String,
    interfaces: Seq[String],
    fields: Seq[DexField],
    methods: Seq[DexMethod]
) {}

case class DexField(shortName: String, name: String, dexType: DexType) {}

case class DexMethod(
    shortName: String,
    name: String,
    paramTypes: Seq[DexType],
    returnType: DexType,
    registersCount: Int,
    paramsCount: Int,
    instructions: Seq[Instruction]
) {
  val localRegistersCount: Int = registersCount - paramsCount
}
