package taint

class SourcesSinks(val sources: Seq[Source], val sinks: Seq[Sink]) {

  def isSource(className: String, methodName: String): Boolean = {
    sources.exists(s => s.className == className && s.methodName == methodName)
  }

  def isSink(className: String, methodName: String): Boolean = {
    sinks.exists(s => s.className == className && s.methodName == methodName)
  }
}

case class Source(className: String, methodName: String) {}

case class Sink(className: String, methodName: String) {}
